uniform mat4	uniViewProjectionMatrix;
uniform vec4	uniColor;	//	premultiplied alpha
uniform vec3	uniDiffuseEvaluator,
				uniSpecularEvaluator;
uniform float	uniAmbientFactor,
				uniDiffuseFactor,
				uniSpecularFactor;

in mat3			atrModelMatrix;
in vec3			atrPosition;
in vec3			atrNormal;
in vec2			atrTextureCoordinates;

out vec2		varTextureCoordinates;
out float		varDiffuseFactor,
				varSpecularFactor;


void main()
{
	vec3	tmpNormal;
	float	tmpDiffuseFactor,
			tmpSpecularFactor;

	gl_Position = uniViewProjectionMatrix * vec4(atrModelMatrix * atrPosition, 1.0);

	varTextureCoordinates = atrTextureCoordinates;

	//	Strictly speaking the surface normal is a 1-form, not a vector,
	//	but for rigid motions in Euclidean space, 1-forms and vectors
	//	transform the same way.
	tmpNormal			= atrModelMatrix * atrNormal;
	varDiffuseFactor	= uniAmbientFactor + uniDiffuseFactor * max(0.0, dot(uniDiffuseEvaluator, tmpNormal));
	varSpecularFactor	= uniSpecularFactor * pow(max(0.0, dot(uniSpecularEvaluator, tmpNormal)), 64.0);
}
